/*
    CaPriCe Forever - Amstrad CPC 464/664/6128 emulator
    Copyright (C) 2014-2020 by Frédéric Coste

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <vcl.h>
#pragma hdrstop
#include "TCheatActionMouse.h"
#if (__BORLANDC__ == 0x551) // Borland C++ Builder 5 Update 1
#include "..\Forms\TFormMain.h"
#else /* __BORLANDC__ */
#include "..\Forms_XE3\TFormMain.h"
#endif /* __BORLANDC__ */

//---------------------------------------------------------------------------

#pragma package(smart_init)


__fastcall TCheatActionMouse::TCheatActionMouse(AnsiString Command) : TCheatAction()
//
// Constructor
//
{
  int ParamPos = Command.Pos("=");
  int ParamLength = Command.Length() - ParamPos;
  int CommentPos = Command.Pos(";");

  if (CommentPos)
  {
    ParamLength = CommentPos - ParamPos - 1;
  }
  else
  {
    CommentPos = Command.Length();
  }

  if (ParamPos < CommentPos)
  {
    mBehaviour = Command.SubString(ParamPos+1, ParamLength).Trim().LowerCase();
    mValid = true;
  }
}
//---------------------------------------------------------------------------


__fastcall TCheatActionMouse::~TCheatActionMouse(void)
//
// Destructor
//
{
}
//---------------------------------------------------------------------------


void __fastcall TCheatActionMouse::Execute(tNativeCPC* NativeCPC)
{
  if (mBehaviour == "lightpen")
  {
    FormMain->SetMouseAsLightpen();
  }
  else if (mBehaviour == "magnum")
  {
    FormMain->SetMouseAsMagnumLightPhaser();
  }
  else if (mBehaviour == "gunstick")
  {
    FormMain->SetMouseAsGunStick();
  }
  else if (mBehaviour == "westphaser")
  {
    FormMain->SetMouseAsWestPhaser();
  }
  else
  {
    FormMain->SetMouseAsMouse();
  }
  
  NOT_USED(NativeCPC);
}
//---------------------------------------------------------------------------
